/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "qar.h"

extern "C" QplugReturnStatus QarLOG10( QplugArgList *);

QplugReturnStatus QarLOG10  ( QplugArgList *call_list )

{
QplugReturnStatus	status;
int qar_status;


QdObject_var in_ptr;
QdObject_var out_ptr;

char * out_name;

status = QPLUG_SUCCESS;


//	Unpack the input data objects

 in_ptr = (*call_list)[0];

// Get name of output object

 char * slot_ptr = GetSlotText(0);
 if ( slot_ptr[0] != '\0' ) {
    out_name = QplugNewSTR(slot_ptr);
 }
 else{
    out_name = QplugNewSTR("Log");
    SetSlotText(0,out_name);
 }


// get base SI for input data

  if( QarHasUnits(in_ptr) ){
    // issue warning
    QplugAppendTextDisplay ("WARNING>> Subject has units.\a \n");  
  }


// do arithmetic...


out_ptr = log10(in_ptr);

if (out_ptr.is_nil()) {
    QplugAppendTextDisplay (
        "Arithmetic>> Log is not supported between these input types\n");
    return QPLUG_FAILURE; 
}

 // Add timeline (or DEPEND_0) : Either timeline is safe if it exists
 QdObject_var qd0 = get_Depend_0( in_ptr );
 if ( !qd0.is_nil() ) out_ptr->change_xref(DEPEND_0 , qd0 );


 // Set QSAS essential attributes
 
  
   // SI_conversion
   
     // Not meaningfol for a log whatever the inputs
  
   // UNITS
 
      // Not meaningfol for a log whatever the inputs

 // FIELDNAM

   QuSetTxtAttr("FIELDNAM", out_name, out_ptr);
   free (out_name);
 
 // Frame
 
   QuSetTxtAttr("Frame", "scalar>na", out_ptr);
 
   // LABLAXIS
	QString labl_s = "log10(";
	labl_s += QuGetAttrText( "LABLAXIS", in_ptr ).c_str();
	labl_s += ")";
	QuSetTxtAttr( "LABLAXIS", labl_s.toLatin1().data(), out_ptr );



  //	..add  the output series to the list

  call_list->push_back(out_ptr);

  QplugAppendTextDisplay ("Logarithm: Done\n");
  
return status;

}

