/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "qar.h"

extern "C" QplugReturnStatus QarMOD(QplugArgList *);

QplugReturnStatus QarMOD  ( QplugArgList *call_list )

{
QplugReturnStatus	status;
int qar_status;

QdObject_var in_ptr;
QdObject_var  out_ptr;

string attr_ptr;
string string_buf;
char * out_name;

status = QPLUG_SUCCESS;


//	Unpack the input data objects
//
//	..first input item is  Any DO

 in_ptr = (*call_list)[0];


// Get name of output object

 char * slot_ptr = GetSlotText(0);
 if ( slot_ptr[0] != '\0' ) {
    out_name = QplugNewSTR(slot_ptr);
 }
 else{
    out_name = QplugNewSTR("ModObj");
    SetSlotText(0,out_name);
 }

// do arithmetic...

out_ptr = mod(in_ptr);

if (out_ptr.is_nil()) {
    QplugAppendTextDisplay (
        "Arithmetic>> This Operation is not supported for this input type\n");
    return QPLUG_FAILURE; 
}

 // Add timeline (or DEPEND_0) : Either timeline is safe if it exists
 QdObject_var qd0 = get_Depend_0( in_ptr );
 if ( !qd0.is_nil() ) out_ptr->change_xref(DEPEND_0 , qd0 );


 // Set QSAS essential attributes
 
 // SI_conversion

 attr_ptr = QuGetAttrText("SI_conversion", in_ptr);
 QuSetTxtAttr("SI_conversion", attr_ptr.c_str(), out_ptr);
 
 
 // FIELDNAM

 attr_ptr = QuGetAttrText("FIELDNAM", in_ptr);
 if( !attr_ptr.empty() ){
   string_buf = "mod: ";
   string_buf += attr_ptr;
   QuSetTxtAttr("FIELDNAM", string_buf.c_str(), out_ptr);
 }
 
 // Frame
 
  // output is always a scalar
  
   QuSetTxtAttr("Frame", "scala>na", out_ptr);
 
 
 // UNITS
 
 attr_ptr = QuGetAttrText("UNITS", in_ptr);
 if( !attr_ptr.empty() ){
   QuSetTxtAttr("UNITS", attr_ptr.c_str(), out_ptr);
 }

   // LABLAXIS
	QString labl_s = "|";
	labl_s += QuGetAttrText( "LABLAXIS", in_ptr ).c_str();
	labl_s += "|";
	QuSetTxtAttr( "LABLAXIS", labl_s.toLatin1().data(), out_ptr );


  //	..add  the output series to the list

  call_list->push_back(out_ptr);

  QplugAppendTextDisplay ("Mod: Done\n");
  
return status;

}

