#include "qOperators.h"


QdObject_var QdAbsValue( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QplugReturnStatus	status      = QPLUG_SUCCESS;;
    int                 nQarStatus;
	QdObject_var        qdResult;
	string              attrPtr;

	if ( qdOperand1.is_nil() )
    {
        // The object will be empty - this should never happen
		// The qdResult object is NULL at this point
        return ( qdResult );
    }


	// do arithmetic...
	qdResult = abs( qdOperand1 );
	if (qdResult.is_nil())
	{
		rqstrErrorMsg = QString ( "The Operation absolute value is not yet supported for this input type" );
		return ( qdResult );
	}


	// Add timeline (or DEPEND_0) : Either timeline is safe if it exists
	QdObject_var qd0 = get_Depend_0( qdOperand1 );
	if ( !qd0.is_nil() ) qdResult->change_xref(DEPEND_0 , qd0 );

	// Set QSAS essential attributes

	// SI_conversion
	attrPtr = QuGetAttrText( "SI_conversion", qdOperand1 );
	if( !attrPtr.empty() )
	{
		QuSetTxtAttr( "SI_conversion", attrPtr.c_str(), qdResult );
	}

	// Frame
	attrPtr = QuGetFrameAttr( qdOperand1 );
	if( !attrPtr.empty() )
	{
		QuSetFrame( qdResult, attrPtr.c_str() );
	}
	
	// UNITS
	attrPtr = QuGetAttrText( "UNITS", qdOperand1 );
	if( !attrPtr.empty() )
	{
		QuSetTxtAttr( "UNITS", attrPtr.c_str(), qdResult );
	}

	// LABLAXIS
	QString labl_s = "|";
	labl_s += QuGetAttrText( "LABLAXIS", qdOperand1 ).c_str();
	labl_s += "|";
	QuSetTxtAttr( "LABLAXIS", labl_s.toLatin1().data(), qdResult );


	return ( qdResult );
}


