#include "qOperators.h"


QdObject_var QdChSign( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

	QplugReturnStatus	status      = QPLUG_SUCCESS;;
	QdObject_var        qdResult;
	string               attrPtr;

	if ( qdOperand1.is_nil() )
    {
        // The object will be empty - this should never happen
		// The qdResult object is NULL at this point
		QcalcAppendTextDisplay( "Change Signe operation error: Operand object is NULL" );
        return ( qdResult );
    }

	// do arithmetic...
	try
	{
		qdResult = - qdOperand1;
	}
	catch( Exception &e )
	{
		QcalcAppendTextDisplay ( e.msg().c_str() );
		QcalcAppendTextDisplay( "This Operation Change Sign is not yet supported between these input types");
		rqstrErrorMsg = QString( "This Operation Change Sign is not yet supported between these input types");
		return ( qdResult );
	}

	if (qdResult.is_nil())
	{
		QcalcAppendTextDisplay( "This Operation change signe is not yet supported for this input type" );
		rqstrErrorMsg = QString ( "This Operation change signe is not yet supported for this input type" );
		return ( qdResult );
	}

	// Add timeline (or DEPEND_0) : Either timeline is safe if it exists
	QdObject_var qd0 = get_Depend_0( qdOperand1 );
	if ( !qd0.is_nil() ) qdResult->change_xref(DEPEND_0 , qd0 );


	// Set QSAS essential attributes

	// SI_conversion
	attrPtr = QuGetAttrText( "SI_conversion", qdOperand1 );
	if( !attrPtr.empty() )
	{
		QuSetTxtAttr( "SI_conversion", attrPtr.c_str(), qdResult );
	}

	// Frame
	string frPtr = QuGetFrameAttr( qdOperand1 );
	if( !frPtr.empty() )
	{
		QuSetFrame(qdResult, frPtr.c_str() );
	}

	// UNITS
	attrPtr = QuGetAttrText( "UNITS", qdOperand1 );
	if( !attrPtr.empty() )
	{
		QuSetTxtAttr( "UNITS", attrPtr.c_str(), qdResult );
	}

	// LABLAXIS
	QString labl_s = "-";
	labl_s += QuGetAttrText( "LABLAXIS", qdOperand1 ).c_str();
	QuSetTxtAttr( "LABLAXIS", labl_s.toLatin1().data(), qdResult );

	// DEPEND_i
    if (qdOperand1->xref_exists(DEPEND_1)) 
    {
        QdObject_var d1_xref = qdOperand1->get_xref(DEPEND_1);
        qdResult->change_xref( DEPEND_1, d1_xref  );
    }
   
    if (qdOperand1->xref_exists(DEPEND_2)) 
    {
        QdObject_var d1_xref = qdOperand1->get_xref(DEPEND_2);
        qdResult->change_xref( DEPEND_2, d1_xref  );
    }

    if (qdOperand1->xref_exists(DEPEND_3)) 
    {
        QdObject_var d1_xref = qdOperand1->get_xref(DEPEND_3);
        qdResult->change_xref( DEPEND_3, d1_xref  );
    }
    
	return ( qdResult );
}


