#include "qOperators.h"


QdObject_var QdExp( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

    QdObject_var  qdResult;

    if ( qdOperand1.is_nil() )
    {
        // The object will be empty - this should never happen
		// The qdResult object is NULL at this point
        return ( qdResult );
    }
	
	// do arithmetic...
	try
	{
		qdResult = exp( qdOperand1 );
	}
	catch( Exception &e )
	{
		QcalcAppendTextDisplay ( e.msg().c_str() );
		QcalcAppendTextDisplay( "The operation Exp is not yet supported for the input type");
		rqstrErrorMsg = QString( "The operation Exp is not yet supported for the input type");
		return ( qdResult );
	}

	if ( qdResult.is_nil() )
	{
		QcalcAppendTextDisplay( "Arithmetic>> Exp is not yet supported for the input type" );
		rqstrErrorMsg = QString( "Arithmetic>> Exp is not yet supported for the input type" );
		return ( qdResult );
	}

	// Add timeline (or DEPEND_0) : Either timeline is safe if it exists
	QdObject_var qd0 = get_Depend_0( qdOperand1 );
	if ( !qd0.is_nil() ) qdResult->change_xref(DEPEND_0 , qd0 );

 	// Set QSAS essential attributes

   	// SI_conversion

    // Not meaningfol for exp whatever the inputs

   	// UNITS

	// Not meaningfol for exp whatever the inputs

	// LABLAXIS
	QString labl_s = "exp(";
	labl_s += QuGetAttrText( "LABLAXIS", qdOperand1 ).c_str();
	labl_s += ")";
	QuSetTxtAttr( "LABLAXIS", labl_s.toLatin1().data(), qdResult );

 	// Frame
   	QuSetFrame( qdResult, "scalar" );

    return ( qdResult );
}


