#include "qOperators.h"


QdObject_var QdCos( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult = QdTrigFunction ( &QdcosLocal,
                                              qdOperand1,
	  	  	                      	      qdOperand2,
                                              rqstrErrorMsg,
		 	                      new QdString(  "cos(" ),
					      false
			                 );

      return ( qdResult );
}

QdObject_var QdSin( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdsinLocal,
                                              qdOperand1,
							           qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "sin(" ),
											  false
							                );

    return ( qdResult );
}

QdObject_var QdTan( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult = QdTrigFunction ( &QdTangent,
                                              qdOperand1,
							           qdOperand2,
                                              rqstrErrorMsg,
							           new QdString(  "tan(" ),
									 false
							                 );

    return ( qdResult );
}

QdObject_var QdCot( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdCTangent,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "cot(" ),
											  false
							                 );

    return ( qdResult );
}

QdObject_var QdCosh( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult = QdTrigFunction ( &QdcoshLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "cosh(" ),
											  false,
											  true
							                 );

    return ( qdResult );
}

QdObject_var QdSinh( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult = QdTrigFunction (  &QdsinhLocal,
                                               qdOperand1,
							                   qdOperand2,
                                               rqstrErrorMsg,
							                   new QdString(  "sinh(" ),
											   false,
											   true
							                 );

    return ( qdResult );
}

QdObject_var Qdtanh( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

  QdObject_var  qdResult = QdTrigFunction (   &QdTangentH,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "tanh(" ),
											  false,
											  true
							                 );

    return ( qdResult );
}

QdObject_var QdCoth( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdCTangentH,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "coth(" ),
											  false,
											  true
							                 );

    return ( qdResult );
}


QdObject_var QdaCos(     QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAcosLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "acos(" ),
											  true,
											  false
							                 );

    return ( qdResult );
}

QdObject_var QdaSin(     QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAsinLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "asin(" ),
											  true,
											  false
							                 );

    return ( qdResult );
}

QdObject_var QdaTan(     QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAtanLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "atan(" ),
											  true,
											  false
							                 );

    return ( qdResult );
}

QdObject_var QdaTan2(     QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{
	QdObject_var  qdResult =  atan2( qdOperand1, qdOperand2 ) ;

	const char* SIconvr = "1 > radian" ;


	if ( ( qdResult.is_nil() ) || ( is_empty( qdResult ) ) )
	{
		rqstrErrorMsg =  QString( "Error>> invalid input to the trigonometry function. Empty object returned." );
		QcalcAppendTextDisplay( "Error>> invalid input to the trigonometry function.. Empty object returned" );
		return ( qdResult );
	}

	// Set xrefs
	
	QuSetTxtAttr( "SI_conversion", SIconvr, qdResult );

	QuSetTxtAttr( "UNITS", "rad", qdResult );

	string labl_txt1 = QuGetAttrText( "LABLAXIS", qdOperand1 );
	string labl_txt2 = QuGetAttrText( "LABLAXIS", qdOperand2 );
	QdString_var labl_s = new QdString( "atan2(" );


	*labl_s += labl_txt1.c_str();
	*labl_s += ", ";
	*labl_s += labl_txt2.c_str();
	*labl_s += ")";


	QuSetTxtAttr( "LABLAXIS", labl_s->c_str(),  qdResult );
	

	if(qdOperand1->xref_exists("FILLVAL")){
		qdResult->change_xref("FILLVAL", qdOperand1->get_xref("FILLVAL"));
	}
	
	// Add timeline (or DEPEND_0) : Either timeline is safe if it exists
	QdObject_var qd0 = get_Depend_0( qdOperand1 );
	if ( qd0.is_nil() ) qd0 = get_Depend_0( qdOperand2 );
	if ( !qd0.is_nil() ) qdResult->change_xref(DEPEND_0 , qd0 );

     return ( qdResult );
}

QdObject_var QdaCot(     QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAcotLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "acot(" ),
											  true,
											  false
							                 );

    return ( qdResult );
}

QdObject_var QdaCosh(    QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAcoshLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "acosh(" ),
											  true,
											  true
							                 );

    return ( qdResult );
}

QdObject_var QdaSinh(    QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAsinhLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "asinh(" ),
											  true,
											  true
							                 );

    return ( qdResult );
}

QdObject_var Qdatanh(    QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAtanhLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "atanh(" ),
											  true,
											  true
							                 );

    return ( qdResult );
}

QdObject_var QdaCoth(    QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAcothLocal,
                                              qdOperand1,
							           qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "acoth(" ),
											  true,
											  true
							                 );

    return ( qdResult );
}


QdObject_var QdTrigFunction ( QdObjectFnPtr pFn,
                              QdObject_var  qdOperand1,
						QdObject_var  qdOperand2,
                              QString&      rqstrErrorMsg,
						QdString_var  funct,
						bool          bInverse,
						bool          bHyperbolic )
{
	QdObject_var qdResult;
	if ( ( qdOperand1.is_nil() ) || ( qdOperand2.is_nil() ) )
    {
        // The object will be empty - this should never happen
	    // The qdResult object is NULL at this point
        return ( qdResult );
    }

	if ( funct.is_nil() )
	{
		return ( qdResult );
	}

	if ( pFn == NULL )
	{
		return ( qdResult );
	}


	QdRScalar_var unit = new QdRScalar(1.0) ;	
	
	double pi = 4.0*atan(1.0);
	QdObject_var  DegToRadObj = new QdRScalar( pi / 180.0 );
	if ( DegToRadObj.is_nil() )
	{
		return ( qdResult );
	}

	QdObject_var  anyObj      = qdOperand1;

	if ( qdOperand1.is_nil() )
	{
		QcalcAppendTextDisplay( "Error>> 1st input neither const nor sequence." );
		rqstrErrorMsg = QString( "Error>> input neither const nor sequence." );
		return ( qdResult );
	}

	QdRScalar_var qdDegRad = QdRScalar_var::narrow( qdOperand2 );
	if ( qdDegRad.is_nil() )
	{
		QcalcAppendTextDisplay( "Error>> Deg/Rad unspecified." );
		rqstrErrorMsg = QString( "Error>> Deg/Rad unspecified." );
		return ( qdResult );
	}

	int nDegRadId = ( int )( *qdDegRad );

	//-----check and read what's in the SI_conversion ----------

	string SIconvr   =  QuGetAttrText( "SI_conversion", qdOperand1 );

	string rbuf;
	string tmpbuf;
	if ( SIconvr.empty() )
	{
		SIconvr = "1 > unk";
	}	

	tmpbuf = SIconvr;
	size_t sepPtr = SIconvr.find(">");
	size_t endPtr = SIconvr.size();
	
	if( sepPtr != string::npos)
	{
		sepPtr++; // move past ">"
		
		*unit = atof(SIconvr.c_str() );
		
		//pick up the RHS of the SI_conversion and put it into rbuf
		// remove white space from start
		while(sepPtr < endPtr && SIconvr[sepPtr] == ' ') sepPtr++;
		
		//remove white space from end
		endPtr--;
		while( endPtr > sepPtr && SIconvr[endPtr] == ' ') endPtr--;

		rbuf = SIconvr.substr(sepPtr, endPtr - sepPtr );
		
	}
	else
	{
		//  unit already set to 1.0
		
		// rhs
		rbuf = "unk";
	}

	if ( bInverse )
	{
		if ( ( nDegRadId == DEG_ID ) || ( nDegRadId == RAD_ID ) )
		{
      		if ( bHyperbolic )
			{
				QcalcAppendTextDisplay( "Error>> output in degree/rad for non-hyperbolic functions only" );
				rqstrErrorMsg = QString( "Error>> output in degree/rad for non-hyperbolic functions only" );
				return ( qdResult );
      		}
   		}

   		if ( ( nDegRadId == DEFAULT_ID ) && ( !bHyperbolic ) )
		{
			QcalcAppendTextDisplay( "Error>> must specify degree or rad for non-hyperbolic functions." );
      		rqstrErrorMsg = QString( "Error>> must specify degree or rad for non-hyperbolic functions." );
			return ( qdResult );
   		}
	}
	else if ( !bHyperbolic )
	{
		//if nDegRadId is degree or rad than ignore SI_conversion as it probably isn't a valid angle : pulldown is set in GUI
		switch ( nDegRadId )
		{
			case DEG_ID:
				if ( rbuf.find("deg") == string::npos )
				{
					QcalcAppendTextDisplay( "WARNING>> Ignoring invalid SI_conversion" );
					rbuf += " as deg";
				}
				else
				{
					//if there's a match, then get the right unit

					anyObj  = ( ( QdObject_var) unit ) * qdOperand1;
					
				}
				anyObj = DegToRadObj * anyObj;//transform to rad
				break;

			case RAD_ID:
				if ( rbuf.find("rad") == string::npos )
				{
					QcalcAppendTextDisplay( "WARNING>> Ignoring invalid SI_conversion" );
					rbuf += " as rad";
				}
				else
				{

					anyObj = ( ( QdObject_var) unit ) * qdOperand1;
					
				}
				break;

			case DEFAULT_ID:
				if ( rbuf.find("rad") != string::npos )
				{
					anyObj  = ( ( QdObject_var )unit ) * qdOperand1;
				}
				else if	( rbuf.find("deg") != string::npos )
				{
					anyObj  = ( ( QdObject_var )unit )*qdOperand1;
					anyObj = DegToRadObj * anyObj;//transform to rad
				}
				else 
				{
					//if not hyperbolic function
			
					rqstrErrorMsg = QString( "Error>> Input is neither in rad nor in degree. Please specify" );
					QcalcAppendTextDisplay( "Error>> Input is neither in rad nor in degree. Please specify" );
					return ( qdResult );
				}
				break;

		default:
				rqstrErrorMsg = QString( "ERROR>> radian/degree flag choice not set. Notify csc support" );
				QcalcAppendTextDisplay( "ERROR>> radian/degree flag choice not set. Check SI_conversion xref" );
				return ( qdResult );
				break;

		}
	}

	// DO TRIG OPERATION
	try
	{
		if ( bInverse )
		{
			qdResult = ( *pFn )( anyObj, &rqstrErrorMsg );
			if ( !rqstrErrorMsg.isEmpty() )
			{
				return ( qdResult );
			}
		}
		else
		{
			qdResult = ( *pFn )( anyObj, NULL );
		}
	}
	catch( Exception & e)
	{
		e.print_msg();
		QcalcAppendTextDisplay( e.msg().c_str() );
		rqstrErrorMsg = QString( "Error>> Nil Exception..." );
		return ( qdResult );
	}


	if ( ( qdResult.is_nil() ) || ( is_empty( qdResult ) ) )
	{
		rqstrErrorMsg =  QString( "Error>> invalid input to the trigonometry function. Empty object returned." );
		QcalcAppendTextDisplay( "Error>> invalid input to the trigonometry function.. Empty object returned" );
		return ( qdResult );
	}

	if ( bInverse )
	{
		double pi = 4.0*atan(1.0);

		QdRScalar_var qdRadToDeg = new QdRScalar( 180.0 / pi );
		if ( nDegRadId == DEG_ID ) //then transform to output to degree
		{
		qdResult = ( ( QdObject_var )qdRadToDeg ) * qdResult;
		}
	}

	// Set xrefs
	
	QdString_var newSI = new QdString( "1.0 >" );

	if ( bInverse && !bHyperbolic )
	{
		if (nDegRadId == RAD_ID) *newSI += "radian";
		else if(nDegRadId == DEG_ID) *newSI += "degree";
		else *newSI += "(unknown)";
	}
	else 
	{
		*newSI += "(";
		*newSI += *funct;
		*newSI += rbuf;
		*newSI += "))";
	}
	
	QuSetTxtAttr( "SI_conversion", newSI->c_str(), qdResult );

	string unit_s = funct->c_str();
	
	if ( bInverse && !bHyperbolic )
	{
		if (nDegRadId == RAD_ID) unit_s = "rad";
		else if(nDegRadId == DEG_ID) unit_s = "deg";
		else {
			unit_s += QuGetAttrText( "UNITS", qdOperand1 ).c_str();
			unit_s += ")";
		}
	}
	else 
	{
		unit_s += QuGetAttrText( "UNITS", qdOperand1 ).c_str();
		unit_s += ")";
	}
	
	QuSetTxtAttr( "UNITS", unit_s.c_str(), qdResult );

	string labl_s = funct->c_str();

	labl_s += QuGetAttrText( "LABLAXIS", qdOperand1 ).c_str();
	labl_s += ")";

	QuSetTxtAttr( "LABLAXIS", labl_s.c_str(), qdResult );

	if(qdOperand1->xref_exists("FILLVAL")){
		qdResult->change_xref("FILLVAL", qdOperand1->get_xref("FILLVAL"));
	}
	QuSetTxtAttr( SCALEMAX, QuGetAttrText( "SCALEMAX", qdOperand1 ).c_str(), qdResult );
	QuSetTxtAttr( SCALEMIN, QuGetAttrText( "SCALEMIN", qdOperand1 ).c_str(), qdResult );
	QuSetTxtAttr( SCALETYP, QuGetAttrText( "SCALETYP", qdOperand1 ).c_str(), qdResult );

	// Add timeline (or DEPEND_0) : Either timeline is safe if it exists
	QdObject_var qd0 = get_Depend_0( qdOperand1 );
	if ( !qd0.is_nil() ) qdResult->change_xref(DEPEND_0 , qd0 );

	

	return ( qdResult );
}

QdObject_var QdAcosLocal(     QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdRScalar_var one = new QdRScalar( 1.0 );
	QdObject_var  tmpObj;
	QdObject_var  qdResult;

	tmpObj = abs( qdOperand1 );
	if ( tmpObj > ( QdObject_var )one )
	{
		*pstrErrorMsg = QString( "Error>> Cannot compute acos of |data|>1." );
		QcalcAppendTextDisplay( "Error>> Cannot compute acos of |data|>1." );
		return ( qdResult );
	}

	qdResult =  acos( qdOperand1 ) ;
	return ( qdResult );
}

QdObject_var QdAsinLocal(     QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult;
	QdRScalar_var one = new QdRScalar( 1.0 );
	if ( one.is_nil() )
	{
		return ( qdResult );
	}
	QdObject_var  tmpObj;


	tmpObj = abs( qdOperand1 );
	if ( tmpObj > ( QdObject_var )one )
	{
		*pstrErrorMsg = QString( "Error>> Cannot compute acos of |data|>1." );
		QcalcAppendTextDisplay( "Error>> Cannot compute acos of |data|>1." );
		return ( qdResult );
	}

	qdResult =  asin( qdOperand1 ) ;
	return ( qdResult );
}

QdObject_var QdAtanLocal(     QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult =  atan( qdOperand1 ) ;
	return ( qdResult );
}


QdObject_var QdAcotLocal(     QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult;
	QdRScalar_var one = new QdRScalar( 1.0 );
	if ( one.is_nil() )
	{
		return ( qdResult );
	}
	qdResult =  atan( ( QdObject_var )one / qdOperand1 ) ;
	return ( qdResult );
}

QdObject_var QdAcoshLocal(    QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult;
	QdRScalar_var one = new QdRScalar( 1.0 );
	if ( one.is_nil() )
	{
		return ( qdResult );
	}

	if ( qdOperand1 < ( QdObject_var )one )
	{
		*pstrErrorMsg = QString( "Error>> Cannot compute acosh of data<1." );
		QcalcAppendTextDisplay( "Error>> Cannot compute acosh of data<1." );
		return ( qdResult );
	}

	qdResult =  log( qdOperand1 + sqrt( qdOperand1*qdOperand1 - ( QdObject_var )one ) ) ;
	return ( qdResult );
}

QdObject_var QdAsinhLocal(    QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult;
	QdRScalar_var one = new QdRScalar( 1.0 );
	if ( one.is_nil() )
	{
		return ( qdResult );
	}
	qdResult =  log( qdOperand1 + sqrt( qdOperand1 * qdOperand1 + ( QdObject_var )one ) ) ;
	return ( qdResult );
}

QdObject_var QdAtanhLocal(    QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult;
	QdRScalar_var one = new QdRScalar( 1.0 );
	if ( one.is_nil() )
	{
		return ( qdResult );
	}
	QdObject_var  tmpObj;
	QdRScalar_var half = new QdRScalar( 0.5 );
	if ( half.is_nil() )
	{
		return ( qdResult );
	}

	tmpObj = abs( qdOperand1 );
	if ( tmpObj >= ( QdObject_var )one )
	{
		*pstrErrorMsg = QString( "Error>> Cannot compute atanh of |data|>= 1" );
		QcalcAppendTextDisplay( "Error>> Cannot compute atanh of |data|>= 1" );
		return ( qdResult );
	}

	qdResult =  ( QdObject_var )half * log( ( ( QdObject_var )one + qdOperand1 ) / ( ( QdObject_var )one - qdOperand1 ) ) ;
	return ( qdResult );
}
  
QdObject_var QdAcothLocal(    QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult;
	QdRScalar_var one  = new QdRScalar( 1.0 );
	if ( one.is_nil() )
	{
		return ( qdResult );
	}

	QdRScalar_var half = new QdRScalar( 0.5 );
	if ( half.is_nil() )
	{
		return ( qdResult );
	}

	qdResult =  ( QdObject_var )half * log( ( ( QdObject_var )one + qdOperand1 ) / ( qdOperand1 - ( QdObject_var )one ) ) ;
	return ( qdResult );
}

QdObject_var QdTangent(   QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var qdResult =  sin( qdOperand1 ) / cos( qdOperand1 ) ;
	return ( qdResult );
}


QdObject_var QdCTangent(  QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult =  cos( qdOperand1 ) / sin( qdOperand1 ) ;
	return ( qdResult );
}


QdObject_var QdTangentH(  QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult =  sinh( qdOperand1 ) / cosh( qdOperand1 ) ;
	return ( qdResult );
}


QdObject_var QdCTangentH( QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult =  cosh( qdOperand1 ) / sinh( qdOperand1 ) ;
	return ( qdResult );
}


QdObject_var QdcosLocal(       QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	return ( cos( qdOperand1 ) );
}

QdObject_var QdsinLocal(       QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	return ( sin( qdOperand1 ) );
}

QdObject_var QdcoshLocal(      QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	return ( cosh( qdOperand1 ) );
}

QdObject_var QdsinhLocal(      QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	return ( sinh( qdOperand1 ) );
}








