#include "qcalcEvaluator.h"


void QEvaluatorAbs::evaluate(QVector<VInSlot*>& in, QVector<VOutSlot*>& out, bool& ok, QString& message)
{
	ok=true;
	QdObject_var result;
	string attrPtr;
	
	QEvaluator::evaluate(in, out, ok, message);
	if(!ok)
		return;
	
	QdObject_var val1=in[0]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[0]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	
	bool isVector1=QuIsThreeVector(val1);
	if(isVector1)
	{
		message=QString("Operation is not valid for vector objects");
		ok=false;
		return;
	}
	
	// do arithmetic...
	result = abs(val1);
	if (result.is_nil())
	{
		message=QString("The Operation absolute value is not yet supported for this input type" );
		ok=false;
		return;
	}

	// get xrefs from inputs if requested
	result->use_xrefs_from(val1);

	// Add timeline (or DEPEND_0) : Either timeline is safe if it exists
	QdObject_var qd0 = get_Depend_0( val1 );
	if ( !qd0.is_nil() ) result->change_xref(DEPEND_0 , qd0 );


	// Set QSAS essential attributes

	// SI_conversion
	attrPtr = QuGetAttrText( "SI_conversion", val1 );
	if( !attrPtr.empty() )
	{
		QuSetTxtAttr( "SI_conversion", attrPtr.c_str(), result );
	}

	// Frame
	QuSetFrame(result, QuGetFrameAttr(val1).c_str());

	// UNITS
	attrPtr = QuGetAttrText("UNITS", val1);
	if( !attrPtr.empty() )
	{
		QuSetTxtAttr( "UNITS", attrPtr.c_str(), result );
	}
	
	// LABLAXIS
	attrPtr = "|";
	attrPtr += QuGetAttrText( "LABLAXIS", val1 );
	attrPtr += "|";
	QuSetTxtAttr( "LABLAXIS", attrPtr.c_str(), result );

	out[0]->setValue(result, true);
}

