#include "qcalcEvaluator.h"


void QEvaluatorLog::evaluate(QVector<VInSlot*>& in, QVector<VOutSlot*>& out, bool& ok, QString& message)
{
	ok=true;
	QdObject_var result;
	string attrPtr;
	
	QEvaluator::evaluate(in, out, ok, message);
	if(!ok)
		return;
	
	QdObject_var val1=in[0]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[0]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	
	bool isVector1=QuIsThreeVector(val1);
	if(isVector1)
	{
		message=QString("Operation is not valid for vector objects");
		ok=false;
		return;
	}
	
	if (QarHasUnits(val1))
	{
		message=QString("WARNING!  Operation Exp() or Log() -> Subject has units");
		ok=false;
		return; //TODO warning rather than error
	}
	
	// do arithmetic...
	try
	{
		result = log(val1);
	}
	catch( Exception &e )
	{
		message=QString(e.msg().c_str());
		message+=QString(" The operation Log is not yet supported between these input types");
		ok=false;
		return;
	}

	if (result.is_nil())
	{
		message=QString("Arithmetic>> Log is not supported between these input types" );
		ok=false;
		return;
	}

	// get xrefs from inputs if requested
	result->use_xrefs_from(val1);

	// Add timeline (or DEPEND_0) : Either timeline is safe if it exists
	QdObject_var qd0 = get_Depend_0( val1 );
	if ( !qd0.is_nil() ) result->change_xref(DEPEND_0 , qd0 );

 	// Set QSAS essential attributes

   	// SI_conversion

    // Not meaningfol for a log whatever the inputs

   	// UNITS

	// Not meaningfol for a log whatever the inputs

	// LABLAXIS
	attrPtr = "ln(";
	attrPtr += QuGetAttrText( "LABLAXIS", val1 );
	attrPtr += ")";
	QuSetTxtAttr( "LABLAXIS", attrPtr.c_str(), result );


 	// Frame
	QuSetFrame(result, "scalar");
	
	out[0]->setValue(result, true);
}

