
/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "qar.h"

extern "C" QplugReturnStatus ToBaseSI  ( QplugArgList *);

QplugReturnStatus ToBaseSI  ( QplugArgList *call_list )

{

QdRScalar_var factor;

QdObject_var in_ptr;
QdObject_var out_ptr;

string attr_ptr;
char * out_name;

 if(call_list->size() < 1) {
    QplugAppendTextDisplay ("no inputs\n");
    return QPLUG_FAILURE; 
 } 
 
//	Unpack the input data objects
//
//	..first input item is  Any DO

//  set pointer to object 

 in_ptr = (*call_list)[0];

 if(in_ptr.is_nil() ){
    QplugAppendTextDisplay ( "Invalid input object \n");
    return QPLUG_FAILURE; 
 }
 

// Get name of output object

 char * slot_ptr = GetSlotText(0);
 if ( strcmp(slot_ptr,"") != 0 ) {
    out_name = QplugNewSTR(slot_ptr);
 }
 else{
    out_name = QplugNewSTR("ObjectInSI");
    SetSlotText(0,out_name);
 }


// create output object

  attr_ptr = QuGetAttrText("SI_conversion", in_ptr);
  if( !attr_ptr.empty() ){
//     factor = new QdRScalar(QarConvFactor(attr_ptr));
      string newAttr = "1 >";
      size_t ptr =  attr_ptr.find(">");
      newAttr +=  attr_ptr.substr(ptr+1);
      out_ptr=QarConvertUnitsTo(in_ptr, newAttr.c_str(), attr_ptr.substr(ptr+1).c_str());
  }
  else{
    QplugAppendTextDisplay ( "No SI conversion metadata available for input object \n");
    return QPLUG_FAILURE; 
  }

  //	..add  the output series to the list

  call_list->push_back(out_ptr);

  QplugAppendTextDisplay ("Convert to Base SI - Done.\n");
  
return QPLUG_SUCCESS;

}

