
/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "qar.h"

extern "C" QplugReturnStatus ToObjUnits  ( QplugArgList *);

QplugReturnStatus ToObjUnits  ( QplugArgList *call_list )

{

  QdRScalar_var factor;
  QdObject_var in_ptr;
  QdObject_var out_ptr;
  QdObject_var SI_target;

  char * out_name;

 if(call_list->size() < 2) {
    QplugAppendTextDisplay ("2 inputs required\n");
    return QPLUG_FAILURE; 
 } 
 
//	Unpack the input data objects
//
//	..first input item is  Any DO

//  set pointer to object 

 in_ptr = (*call_list)[0];

 SI_target = (*call_list)[1];

string SIcTarget =  QuGetAttrText("SI_conversion", SI_target);

string UnitsTarget =  QuGetAttrText("UNITS", SI_target);

 if(in_ptr.is_nil()){
    QplugAppendTextDisplay ( "Invalid input object \n");
    return QPLUG_FAILURE; 
 }
 
 if( SIcTarget.empty()){
    QplugAppendTextDisplay ( "Second object has no SI_conversion \n");
    return QPLUG_FAILURE; 
 }
 if( UnitsTarget.empty()){
	 QplugAppendTextDisplay ( "Second object has no UNITS attribute \n");
	 return QPLUG_FAILURE; 
 }
 
// Get name of output object

 char * slot_ptr = GetSlotText(0);
 if ( strcmp(slot_ptr,"") != 0 ) {
    out_name = QplugNewSTR(slot_ptr);
 }
 else{
    out_name = QplugNewSTR("InNewUnits");
    SetSlotText(0,out_name);
 }


// create output object
  
 try{
    out_ptr = QarConvertUnitsTo(in_ptr, SIcTarget.c_str(), UnitsTarget.c_str()); 
    // this creates new converted object, copies xrefs across and sets SI_conversion
 }
 catch(Exception &e){
    QplugAppendTextDisplay ( e.msg().c_str());
    return QPLUG_FAILURE;   
 }
 
if ( out_ptr.is_nil() ) {
    QplugAppendTextDisplay ("Cannot convert this object to chosen target units\n Target SI_conversion should be of form ...\n");
    string attr_ptr = QuGetAttrText("SI_conversion", in_ptr);
    size_t ptr = attr_ptr.find(">");
    QplugAppendTextDisplay (attr_ptr.substr(ptr+1).c_str());	     
    QplugAppendTextDisplay("\n");
    return QPLUG_FAILURE; 
}
 
 
 // UNITS
  string targetUnits = QuGetAttrText("UNITS", SI_target);

  if(targetUnits.empty()){  // create Units from SI_conversion
    if( !SIcTarget.empty() ){
       size_t ptr = SIcTarget.find(">");
       if(ptr != string::npos) {
         targetUnits = SIcTarget.substr(ptr+1);
         if(atof(SIcTarget.c_str()) != 1){
           targetUnits += " / ";
           targetUnits += SIcTarget.substr(0, ptr);
         }
       }
     }
   }
	QuSetTxtAttr("UNITS", targetUnits.c_str(), out_ptr);


  //	..add  the output series to the list

  call_list->push_back(out_ptr);

  QplugAppendTextDisplay ("Convert to new units - Done.\n");
  
return QPLUG_SUCCESS;

}


