
#ifndef DWT_SET_PLOT_H
#define DWT_SET_PLOT_H

#include "qplug_if.h"
#include "Qdos.h"
#include "PGSpectro.h"
#include "qprofile.h"


extern "C" {
}

//C++ prototypes
/*
QplugReturnStatus ReadFilter(const char* filtname, int len, vector<double>* scalf);
*/

QplugReturnStatus ReadFilter(const char* filtname, QdRScalarSeq_var gf);

QplugReturnStatus  Run_Dwt(QdRScalarSeq_var ts_in, int jsize, 
			QdRScalarSeq_var hf, QdRScalarSeq_var gf, 
			QdRScalarSeq_var wavlcoef);
			
QplugReturnStatus  Run_MoDwt(QdRScalarSeq_var ts_in, int jsize,  
			QdRScalarSeq_var hf, QdRScalarSeq_var gf, 
			QdRScalarSeq_var wavlcoef);
			
QplugReturnStatus SPectro_set(QdRScalarSeq_var wav_mat, QdTimeSeq_var ttag,
		int level, PGSpectro *spectrop, QdRScalarSeq_var gfilt_var, 
		Yes_or_No dwt_yes_no,
		char *x_lab, char *y_lab, char *w_lab);
			
// QplugReturnStatus SPectro_dev(PGSpectro *spectrop, QdRScalar pgdev, 
// 			const char *filename, int& iddev);
			
// QplugReturnStatus XYtrace_set(QdRScalarSeq_var yin, PGXYtrace *trace,
// 			char *x_lab, char *y_lab, 
// 			char *title, char *sbtitle, char *tlegend);
			
// QplugReturnStatus  Time_set(QdTimeSeq_var ttag, PGSpectro *spgp, 
// 			PGXYtrace *tracep, Yes_or_No dwt_yes);
				
QplugReturnStatus SPectro_fill(int nx, int Llen, QdRScalar_var eg, 
		QdRScalarSeq_var wav_seq, PGSpectro *spectrop,
		Yes_or_No dwt_yes_no, QdRMatrix_var z);
					
void Circular_shift(QdRScalarSeq_var seq, int amount);	

Yes_or_No isPowerOf2(long m);
			
char* str_dup(string& s, int len);
	
void clean_all(PGSpectro *spectrop/*, PGXYtrace *tracep*/);	
				
#endif
			
									
