#include "MiscConfig.h"

MiscConfig::MiscConfig()
{
	QGridLayout * layout=new QGridLayout(this);
	
	QLabel * tempLabel=new QLabel("Debug mode: ", this);

	tempLabel->setWordWrap(true);

	layout->addWidget(tempLabel, 0, 0);
	
	debugBox=new QCheckBox(this);
	layout->addWidget(debugBox, 0, 1);
	
	tempLabel=new QLabel("Debug mode (qrtn plugin): ", this);

	tempLabel->setWordWrap(true);

	layout->addWidget(tempLabel, 1, 0);
	
	qrtnDebugBox=new QCheckBox(this);
	layout->addWidget(qrtnDebugBox, 1, 1);
	
	tempLabel=new QLabel("Show Temp folder in WL (debug only)*: ", this);

	tempLabel->setWordWrap(true);

	layout->addWidget(tempLabel, 2, 0);
	
	WLDebugBox=new QCheckBox(this);
	layout->addWidget(WLDebugBox, 2, 1);
	
}

void MiscConfig::updateProfile(QProfile* prof)
{
	prof->Debug=(debugBox->isChecked()?1:0);
	prof->QrtnDebug=(qrtnDebugBox->isChecked()?1:0);
	prof->dbgWL=(WLDebugBox->isChecked()?1:0);
}

void MiscConfig::setSelectedProfile(QProfile * p)
{
	debugBox->setChecked(p->Debug==1);
	qrtnDebugBox->setChecked(p->QrtnDebug==1);
	WLDebugBox->setChecked(p->dbgWL==1);
}
