#include "StringMem.h"
#include <assert.h>

namespace QDOS { 

void *StringMem::realloc(void *old, unsigned data_sz, unsigned old_num, unsigned new_num)
{

    void *s = new char [data_sz * new_num];     // allocate new memory
    if (old_num)                                // copy existing memory, if any
    {
        memcpy(s, *(void **)old, old_num * data_sz);  // copy the old memory
        delete *(char **)old;                   // free the old memory
    }
    return(*(void **)old=s);                    // return the new memory
}

char *StringMem::strdup(char const *s)
{
    char
        *s2=0;

    if (!s)                                   // there is no string to copy: 
        s = "";                               // make empty string

    s2 = new char [1 + strlen(s)];
    assert(s2!=0);

    return (strcpy(s2, s));
}

char *StringMem::strndup(char const *str, unsigned len)
{       
    unsigned
        slen = strlen(str);

    if (len > slen)
        return (strdup(str));            // normal strdup for large len values
        
    if (!str)
        return (0);                      // no str, no copy
        
    char
        *cp;
        
    cp = new char[len + 1];
    cp[len] = 0;                         // make ascii-z string
    if(len)
      memcpy(cp, str, len);                // copy the chars
    
    return (cp);                         // return partially copied string
}

int StringMem::ncmp(char const *s1, char const *s2, unsigned len)
{
  if(!s1 || !s2)
    return (2);
    
  char c1=*s1;
  char c2=*s2;
  
  int x=(c1 != c2)?1:strncmp(s1,s2,len);
  
  if(x<0)
    return (-1);
    
  return (x!=0);
}
  
} // namespace QDOS
